pub const fn bit(v:u32) -> u32 { 1u32 << v }
pub const fn mask(b:u32, s:u32) -> u32 { ((1u32 << b) - 1) << s }

pub const fn lsb(x:u32) -> u32 { x & x.wrapping_neg() }
pub const fn ffs(x:u32) -> u32 { 31 - x.leading_zeros() }

pub const fn rotate6(x:u32) -> u32
{
    const R1 :u32 = 0x0000_003F;
    const R2 :u32 = 0x0000_0FC0;
    const R3 :u32 = 0x0003_F000;
    const R4 :u32 = 0x00FC_0000;

    let a = (x & R1) << 3;
    let b = (x & R2) << 3;
    let c = (x & R3) << 3;
    let d = (x & R4) << 3;

    (a & R1) | ((a >> 6) & R1)
    | (b & R2) | ((b >> 6) & R2)
    | (c & R3) | ((c >> 6) & R3)
    | (d & R4) | ((d >> 6) & R4)
}

pub const fn rotate12(x:u32) -> u32
{
    const R1 :u32 = 0x0000_0FFF;
    const R2 :u32 = 0x00FF_F000;

    let a = (x & R1) << 6;
    let b = (x & R2) << 6;

    (a & R1) | ((a >> 12) & R1)
    | (b & R2) | ((b >> 12) & R2)
}
